
AC_DEFUN(LAC_GRUB_ARGS,
[

dnl check for submodule enable args
dnl order is unimportant

lac_enable_grub_common="no"

AC_ARG_ENABLE(grub-debug,
        [  --enable-grub-debug           enable GRUB debug messages],
        [lac_enable_grub_debug="$enableval"],
        [lac_enable_grub_debug="no"])
AC_ARG_ENABLE(grub-rconsole,
        [  --enable-grub-rconsole        configure GRUB remote console server],
        [lac_enable_grub_rconsole="$enableval"],
        [lac_enable_grub_rconsole="no"])
AC_ARG_ENABLE(grub-rconsole-client,
        [  --enable-grub-rconsole-client configure GRUB remote console client],
        [lac_enable_grub_rconsole_client="$enableval"],
        [lac_enable_grub_rconsole_client="no"])
AC_ARG_ENABLE(grub-client,
        [  --enable-grub-client          configure GRUB client],
        [lac_enable_grub_client="$enableval"],
        [lac_enable_grub_client="no"])
AC_ARG_ENABLE(grub-server,
        [  --enable-grub-server          configure GRUB server],
        [lac_enable_grub_server="$enableval"],
        [lac_enable_grub_server="no"])
AC_ARG_ENABLE(grub-runtime,
        [  --enable-grub-runtime         configure GRUB runtime],
        [lac_enable_grub_runtime="$enableval"],
        [lac_enable_grub_runtime="no"])
AC_ARG_ENABLE(grub-test,
        [  --enable-grub-test            configure GRUB test],
        [lac_enable_grub_test="$enableval"],
        [lac_enable_grub_test="no"])
AC_ARG_ENABLE(grub-test-app,
        [  --enable-grub-test-app        configure GRUB test-app],
        [lac_enable_grub_test_app="$enableval"],
        [lac_enable_grub_test_app="no"])
AC_ARG_ENABLE(grub-tools,
        [  --enable-grub-tools           configure GRUB tools],
        [lac_enable_grub_tools="$enableval"],
        [lac_enable_grub_tools="no"])

])

AC_DEFUN(LAC_GRUB,
[

LAC_GRUB_ARGS

if test "$lac_enable_grub_debug" = "yes" ; then
    grub_debug_flag="-DGRUB_DEBUG"
else
    grub_debug_flag=""
fi

AC_SUBST(grub_debug_flag)

dnl perform dependency-based enables
dnl sorted by submodule dependency to be sure everything is expanded
 
lac_enable_grub_common="no"

if test "$lac_enable_grub_test" = "yes" ; then
    lac_enable_grub_client="yes"
    lac_enable_grub_server="yes"
fi
if test "$lac_enable_grub_tools" = "yes" ; then
    lac_enable_grub_client="yes"
    lac_enable_grub_server="yes"
    lac_enable_grub_rconsole="yes"
fi
if test "$lac_enable_grub_test_app" = "yes" ; then
    lac_enable_grub_runtime="yes"
    lac_enable_grub_rconsole_client="yes"
fi

if test "$lac_enable_grub_client" = "yes" ; then
    lac_enable_grub_common="yes"
fi
if test "$lac_enable_grub_server" = "yes" ; then
    lac_enable_grub_common="yes"
    lac_enable_grub_rconsole="yes"
fi
if test "$lac_enable_grub_runtime" = "yes" ; then
    lac_enable_grub_common="yes"
    lac_enable_grub_rconsole_client="yes"
fi

if test "$lac_enable_grub_rconsole" = "yes" ; then
    lac_enable_grub_common="yes"
fi
if test "$lac_enable_grub_rconsole_client" = "yes" ; then
    lac_enable_grub_common="yes"
fi

])

