/******************************************************************************
Nexus_Listener.H

Description:

  Classes to provide simple Nexus listener functionality

CVS Information:

  $Source$
  $Date$
  $Revision$
  $State$
  $Author$
******************************************************************************/

#if !defined(NEXUS_INCLUDE_NEXUS_LISTENER)
#define NEXUS_INCLUDE_NEXUS_LISTENER 1

/******************************************************************************
			     Include header files
******************************************************************************/
#include "Nexus.H"
#include "nexus.h"


/******************************************************************************
			      Class declarations
******************************************************************************/
class Nexus_Endpoint;


/******************************************************************************
			  Define Nexus_Listener class
******************************************************************************/
class
Nexus_Listener
{
    /**************************************************************************
				    API methods
    **************************************************************************/

    /*
     * Nexus_Listener::Nexus_Listener()
     */
    public:
    Nexus_Listener();

    /*
     * Nexus_Listener::activate()
     */
    public:
    Nexus_Bool
    activate(
	ARG_INMOD Nexus_Endpoint &	endpoint,
	ARG_IN unsigned short		port = 0);
    
    /*
     * Nexus_Listener::get_Hostname()
     */
    public:
    char *
    get_Hostname();

    /*
     * Nexus_Listener::get_Port()
     */
    public:
    unsigned short
    get_Port();
    
    /*
     * Nexus_Listener::deactivate()
     */
    public:
    Nexus_Bool
    deactivate();
    
    /*
     * Nexus_Listener::~Nexus_Listener()
     */
    public:
    ~Nexus_Listener();


    /**************************************************************************
		       Internal methods and data structures
    **************************************************************************/

    /*
     * Nexus_Listener::Object_State
     */
    private:
    enum Object_State
    {
	OBJECT_STATE_INACTIVE,
	OBJECT_STATE_ACTIVE,
	OBJECT_STATE_DELETED
    };

    /*
     * Nexus_Listener::l_deactivate()
     */
    private:
    Nexus_Bool
    l_deactivate();
    
    /*
     * Nexus_Listener::verify_Object_State()
     */
    private:
    Nexus::Status
    verify_Object_State(
	ARG_IN Object_State		desired_state);

    /*
     * Nexus_Listener::handle_Attach()
     */
    private:
    static int
    handle_Attach(
	void *				arg,
	char *				my_url,
	nexus_startpoint_t *		sp_ptr);

    /*
     * Private data members
     */
    private:

    nexus_mutex_t			mutex;
    Nexus_Endpoint *			endpoint;
    char *				hostname;
    unsigned short			port;

    volatile Object_State		object_state;   
};
	
#endif /* NEXUS_INCLUDE_NEXUS_LISTENER */
