/******************************************************************************
Nexus_Receive_Buffer.H

Description:

  Classes to provide simple Nexus functionality

CVS Information:

  $Source$
  $Date$
  $Revision$
  $State$
  $Author$
******************************************************************************/

#if !defined(NEXUS_INCLUDE_NEXUS_RECEIVE_BUFFER)
#define NEXUS_INCLUDE_NEXUS_RECEIVE_BUFFER 1


/******************************************************************************
			     Include header files
******************************************************************************/
#include "Nexus.H"

#include "globus_common.h"
#include "nexus.h"

/******************************************************************************
			       Class prototypes
******************************************************************************/
class Nexus_Startpoint;


/******************************************************************************
		       Define Nexus_Receive_Buffer class
******************************************************************************/
class
Nexus_Receive_Buffer
{
    public:
    Nexus_Receive_Buffer();

    public:
    Nexus_Bool
    activate(
	ARG_INOUT nexus_buffer_t &	nx_buffer);

    public:
    Nexus_Bool
    get_Byte(
	ARG_OUT Nexus_Byte * 		array,
	ARG_IN unsigned			count);

    public:
    Nexus_Bool
    get_Char(
	ARG_OUT char * 			array,
	ARG_IN unsigned			count);

    public:
    Nexus_Bool
    get_Int(
	ARG_OUT int *			array,
	ARG_IN unsigned			count);

    public:
    Nexus_Bool
    get_Startpoint(
	ARG_OUT Nexus_Startpoint *	startpoint,
	ARG_IN unsigned			count);
    
    public:
    Nexus_Bool
    deactivate();
    
    public:
    ~Nexus_Receive_Buffer();

    private:

    enum
    {
	OBJECT_STATE_ACTIVE,
	OBJECT_STATE_INACTIVE,
	OBJECT_STATE_DELETED
    }					object_state;

    nexus_buffer_t			buffer;
};

	
#endif /* NEXUS_INCLUDE_NEXUS_RECEIVE_BUFFER */
